import { html, ref, repeat, when } from '@microsoft/fast-element';
export const buttonCellRenderer = (title, clickHandler) => ({
    width: 100,
    pinned: 'right',
    enableCellChangeFlash: false,
    cellStyle: { padding: '0', lineHeight: '25px' },
    filter: false,
    suppressFiltersToolPanel: true,
    suppressColumnsToolPanel: true,
    headerName: '',
    minWidth: 100,
    maxWidth: 100,
    cellRendererSelector: (params) => params.node.group
        ? undefined
        : {
            component: 'action',
            params: {
                actionClick: clickHandler,
                actionName: title,
                appearance: 'accent',
            },
        },
});
export const listTemplate = html `
  <div class="heading">
    <h3 data-test-id="title">${(x) => x.title}</h3>
    ${when((x) => x.createEvent, html `
        <zero-button
          appearance="accent"
          @click=${(x) => x.create()}
          ?disabled="${(x) => x.addDisabled}"
          data-test-id="button-create"
        >
          Add
        </zero-button>
      `)}
  </div>
  <div class="container">
    ${when((x) => x.enableFilterBar, html `
        <zero-filter-bar
          resource=${(x) => x.resourceName}
          only=${(x) => { var _a; return (_a = x.columns) === null || _a === void 0 ? void 0 : _a.map((colDef) => colDef.field).filter((field) => !!field); }}
          labels=${(x) => { var _a; return (_a = x.columns) === null || _a === void 0 ? void 0 : _a.map((colDef) => colDef.headerName || ''); }}
          target="datasource"
        ></zero-filter-bar>
      `)}
    <zero-grid-pro
      ${ref('grid')}
      auto-cell-renderer-by-type
      rowSelection="single"
      rowHeight="36"
      headerHeight="36"
      persist-column-state-key=${(x) => x.persistColumnStateKey}
      ?only-template-col-defs=${(x) => !!x.columns}
      suppressCellFocus="true"
      suppressRowDeselection="true"
      enable-cell-flashing=${(x) => x.enableCellFlashing}
    >
      <grid-pro-genesis-datasource
        ${ref('datasource')}
        resource-name=${(x) => x.resourceName}
        criteria=${(x) => { var _a; return (_a = x.datasourceConfig) === null || _a === void 0 ? void 0 : _a.criteria; }}
        fields=${(x) => { var _a; return (_a = x.datasourceConfig) === null || _a === void 0 ? void 0 : _a.fields; }}
        is-snapshot=${(x) => { var _a; return (_a = x.datasourceConfig) === null || _a === void 0 ? void 0 : _a.isSnapshot; }}
        max-rows=${(x) => { var _a; return (_a = x.datasourceConfig) === null || _a === void 0 ? void 0 : _a.maxRows; }}
        max-view=${(x) => { var _a; return (_a = x.datasourceConfig) === null || _a === void 0 ? void 0 : _a.maxView; }}
        order-by=${(x) => { var _a; return (_a = x.datasourceConfig) === null || _a === void 0 ? void 0 : _a.orderBy; }}
        reverse=${(x) => { var _a; return (_a = x.datasourceConfig) === null || _a === void 0 ? void 0 : _a.reverse; }}
      ></grid-pro-genesis-datasource>
      ${repeat((x) => x.columns, html `
          <grid-pro-column :definition=${(x) => x}></grid-pro-column>
        `)}
      ${repeat((x) => x.actionButtonsConfig, html `
          <grid-pro-column :definition=${(x) => x}></grid-pro-column>
        `)}
    </zero-grid-pro>
  </div>
`;
